#include <iostream>
#include <iomanip>
#include <cmath>
using namespace std;
int main()
{
    double w,h,r,m,h1,h2,h3;
    int z=0,q,i=0,pomocna1=0,pomocna2=0;
    cin>>w>>h>>r>>q;
    int a[q],b[q],c[q],x[q],y[q],v,p[q],m1;
    for(int i=0; i<q; i++)
    {
        b[i]=-1;
        x[i]=-1;
        y[i]=-1;
    }
    for(int i=0; i<q; i++)
    {
        cin>>a[i];
        if(a[i]==2)
        {
            cin>>b[i];
        }
        else
        {
            z++;
            cin>>x[i]>>y[i];
            p[i]=i;
            m1=i;

        }
    }
    v=q-z;
    while(a[i]==2)
    {
                std::cout << setprecision(12) << fixed;
        std::cout<< h<<endl;
        i++;
        if(i==q)
            return 0;
    }
    for(int i=0; i<v; i++)
    {
        for(int j=1;j<=v-p[i];j++)
        {
        if(x[i]>-1)
        {
            h1=pow(r,2);

            h2=pow(x[i],2)-2*b[j+p[i]]*x[i]+pow(b[j+p[i]],2);

            h3=abs(h1-h2);

            m=y[i]-sqrt(h3);

            if(b[j+p[i]]<=x[i]-r && p[i]!=-1 && j+p[i]<=i)
            {
                std::cout << setprecision(12) << fixed;
        std::cout<< h<<endl;
            }
            else
            {
                std::cout << setprecision(12) << fixed;
        std::cout<< m<<endl;

            }
        }

    }
    }
    return 0;
}